Subject: Re: Packetlost when "tc qdisc del dev eth0 root"

From: Jarek Poplawski <[email-masked]>
Date: Sun, 20 Jan 2008 00:21:56 +0100

Patrick McHardy wrote, On 01/16/2008 06:12 AM:

> [email-masked] wrote:
>> Good night! =)
>>
>> Sorry... i was wrong...
>> I see that problem more serious....
>>
>> Lets see to scheme
>>
>> Class 1
>> ---qdisc
>> ------- 10k classes
>> Class 2
>> ---qdisc
>> ------- 10k classes
>>
>> All traffic go to class 2... class 1 qdisc not have packets and if we 
>> delete it - packets not lost... in theory... lets try delete class 1 
>> qdisc (all childrens delete too)...
>> PC freeze on 2-5 seconds... its not forward any traffic at this 
>> moment... its great tree lock?
>>
>> Its normal or code need to more accurate lock?
> 
> 
> htb class destruction can be quite expansive if one of the rb trees
> needs to be rebalanced. Doing that for 10000 classes would explain
> the delay.

I've just looked at this and it seems there should be no rbtrees operations
during htb qdisc deletion (or I miss something).

Slavon, I see nearby that you teach oprofile...

Regards,
Jarek P.